import processing.core.*; 
import processing.data.*; 
import processing.opengl.*; 

import ddf.minim.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class ball_MI extends PApplet {

/*

 - - - ball-MI - - - 
 performing software
 by Eiichi Ishii
 \u63a8\u5968\u753b\u9762\u30b5\u30a4\u30ba\uff1a1366\u00d7768
 
 */



Minim minim;
AudioSample sound1;
AudioSample sound2;
AudioSample sound3;
AudioSample sound4;
AudioSample sound5;
AudioInput in;

PImage ic;
PImage logo;

Mtoggles mt;
Ntoggles nt;
Ctoggles ct;

float mainCW=255;
float mainCB=0;

int num1=10;
int num2=10;
int num3=10;
int num4=10;
int num5=10;
module1[]m1=new module1[num1];
module2[]m2=new module2[num2];
module3[]m3=new module3[num3];
module4[]m4=new module4[num4];
module5[]m5=new module5[num5];

public void setup() {
  size(displayWidth, displayHeight);
  noSmooth();
  noCursor();
  textAlign(CENTER);

  ic = loadImage("icursor.png");
  logo = loadImage("logo.png");
  minim = new Minim(this);
  sound1 = minim.loadSample("sound1.wav", 2048);
  sound2 = minim.loadSample("sound2.wav", 2048);
  sound3 = minim.loadSample("sound3.wav", 2048);
  sound4 = minim.loadSample("sound4.wav", 2048);
  sound5 = minim.loadSample("sound5.wav", 2048);
  minim.debugOn();
  in = minim.getLineIn(Minim.STEREO, width);

  mt=new Mtoggles(width/27.32f, width/13.66f, width/9.1f, width/6.83f, width/5.464f, height/9.6f, 20, 0, 0, 0, 0, 0, 120, 120, 120, 120, 120);
  nt=new Ntoggles(width/3.04f, width/2.5f, width/2.1f, width/1.82f, width/1.6f, height/9.6f, 20, 0, 0, 0, 0, 0, 120, 120, 120, 120, 120);
  ct=new Ctoggles(width/1.33f, height/9.6f, 20, 0, 0);

  for (int i=0; i<num1; i++) {
    m1[i]=new module1(width/2, height/2, 
    random(-random(5, 10), random(5, 10)), 
    random(-random(5, 10), random(5, 10)), 
    random(30, 100), random(255), random(255), random(255));
  }
  for (int i=0; i<num2; i++) {
    m2[i]=new module2(width/2, height/2, 
    random(-random(5, 10), random(5, 10)), 
    random(-random(5, 10), random(5, 10)), 
    random(30, 100), random(255), random(255), random(255));
  }
  for (int i=0; i<num3; i++) {
    m3[i]=new module3(width/2, height/2, 
    random(-random(5, 10), random(5, 10)), 
    random(-random(5, 10), random(5, 10)), 
    random(30, 100), random(255), random(255), random(255));
  }
  for (int i=0; i<num4; i++) {
    m4[i]=new module4(width/2, height/2, 
    random(-random(5, 10), random(5, 10)), 
    random(-random(5, 10), random(5, 10)), 
    random(30, 100), random(255), random(255), random(255));
  }
  for (int i=0; i<num5; i++) {
    m5[i]=new module5(width/2, height/2, 
    random(-random(5, 10), random(5, 10)), 
    random(-random(5, 10), random(5, 10)), 
    random(30, 100), random(255), random(255), random(255));
  }
}

public void draw() {
  background(mainCW);
  noFill();
  stroke(120);
  strokeWeight(3);
  for (int i = 0; i < in.bufferSize() - 1; i+=10) {
    rect(i, height/2+in.right.get(i)*200, 2+in.right.get(i)*200, 2+in.right.get(i)*200);
  }
  mt.update();
  mt.display();
  nt.update();
  nt.display();
  ct.update();
  ct.display();
  image(ic, mouseX, mouseY);
  image(logo, width/27.32f, height/1.12f);
}

public void mousePressed() {
  nt.changeModule();
  mt.changeModule();
  ct.changeModule();
  if (mouseButton==RIGHT) {
    stroke(mainCB);
    strokeWeight(10);
    noFill();
    ellipse(width/2, height/2, 300, 300);
    for (int i=0; i<num1; i++) {
      m1[i]=new module1(width/2, height/2, 
      random(-random(5, 10), random(5, 10)), 
      random(-random(5, 10), random(5, 10)), 
      random(30, 100), random(255), random(255), random(255));
    }
    for (int i=0; i<num2; i++) {
      m2[i]=new module2(width/2, height/2, 
      random(-random(5, 10), random(5, 10)), 
      random(-random(5, 10), random(5, 10)), 
      random(30, 100), random(255), random(255), random(255));
    }
    for (int i=0; i<num3; i++) {
      m3[i]=new module3(width/2, height/2, 
      random(-random(5, 10), random(5, 10)), 
      random(-random(5, 10), random(5, 10)), 
      random(30, 100), random(255), random(255), random(255));
    }
    for (int i=0; i<num4; i++) {
      m4[i]=new module4(width/2, height/2, 
      random(-random(5, 10), random(5, 10)), 
      random(-random(5, 10), random(5, 10)), 
      random(30, 100), random(255), random(255), random(255));
    }
    for (int i=0; i<num5; i++) {
      m5[i]=new module5(width/2, height/2, 
      random(-random(5, 10), random(5, 10)), 
      random(-random(5, 10), random(5, 10)), 
      random(30, 100), random(255), random(255), random(255));
    }
  }
}

public void stop() {
  in.close();
  sound1.close();
  sound2.close();
  sound3.close();
  minim.stop();
  super.stop();
}

class Ctoggles {
  float X, Y, R, state, F;
  Ctoggles(float X, float Y, float R, float state, float F) {
    this.X=X;
    this.Y=Y;
    this.R=R;
    this.state=state;
    this.F=F;
  }

  public void update() {
    if ( state == 1 ) {
      mainCW=0;
      mainCB=255;
      F=255;
    } 
    else {
      mainCW=255;
      mainCB=0;
      F=0;
    }
  }

  public void display() {
    stroke(120);
    strokeWeight(1);
    fill(F);
    rect(X, Y, R, R);
    fill(120);
    textSize(10);
    text("Change Color", X+30, Y);
  }

  public void changeModule() {
    if ( mouseX>X && mouseX<X+R && mouseY>Y && mouseY<Y+R ) {
      if ( state == 0 ) {
        state = 1;
      } 
      else {
        state = 0;
      }
    }
  }
}

class Mtoggles {
  float T1X, T2X, T3X, T4X, T5X, Y, R, state1, state2, state3, state4, state5, T1F, T2F, T3F, T4F, T5F;
  Mtoggles(float T1X, float T2X, float T3X, float T4X, float T5X, float Y, float R, float state1, 
  float state2, float state3, float state4, float state5, float T1F, float T2F, float T3F, float T4F, 
  float T5F) {
    this.T1X=T1X;
    this.T2X=T2X;
    this.T3X=T3X;
    this.T4X=T4X;
    this.T5X=T5X;
    this.Y=Y;
    this.R=R;
    this.state1=state1;
    this.state2=state2;
    this.state3=state3;
    this.state4=state4;
    this.state5=state5;
    this.T1F=T1F;
    this.T2F=T2F;
    this.T3F=T3F;
    this.T4F=T4F;
    this.T5F=T5F;
  }

  public void update() {
    if ( state1 == 1 ) {
      for (int i=0; i<num1; i++) {
        m1[i].display();
      }
      T1F=mainCB;
    } 
    else {
      T1F=120;
    }
    if ( state2 == 1 ) {
      for (int i=0; i<num2; i++) {
        m2[i].display();
      }
      T2F=mainCB;
    } 
    else {
      T2F=120;
    }
    if ( state3 == 1 ) {
      for (int i=0; i<num3; i++) {
        m3[i].display();
      }
      T3F=mainCB;
    } 
    else {
      T3F=120;
    }
    if ( state4 == 1 ) {
      for (int i=0; i<num4; i++) {
        m4[i].display();
      }
      T4F=mainCB;
    } 
    else {
      T4F=120;
    }
    if ( state5 == 1 ) {
      for (int i=0; i<num5; i++) {
        m5[i].display();
      }
      T5F=mainCB;
    } 
    else {
      T5F=120;
    }
  }

  public void display() {
    stroke(120);
    strokeWeight(1);
    fill(mainCW, 200);
    rect(T1X-10, Y/3, width/3.9f, height/7.7f);
    fill(T1F);
    rect(T1X, Y, R, R);
    fill(T2F);
    rect(T2X, Y, R, R);
    fill(T3F);
    rect(T3X, Y, R, R);
    fill(T4F);
    rect(T4X, Y, R, R);
    fill(T5F);
    rect(T5X, Y, R, R);
    fill(120);
    textSize(20);
    text("Modules", T1X+40, Y-20);
    textSize(10);
    text("S1", T1X+5, Y);
    text("S2", T2X+5, Y);
    text("S3", T3X+5, Y);
    text("S4", T4X+5, Y);
    text("S4", T5X+5, Y);
  }

  public void changeModule() {
    if ( mouseX>T1X && mouseX<T1X+R && mouseY>Y && mouseY<Y+R ) {
      if ( state1 == 0 ) {
        state1 = 1;
      } 
      else {
        state1 = 0;
      }
    }
    if ( mouseX>T2X && mouseX<T2X+R && mouseY>Y && mouseY<Y+R ) {
      if ( state2 == 0 ) {
        state2 = 1;
      } 
      else {
        state2 = 0;
      }
    }
    if ( mouseX>T3X && mouseX<T3X+R && mouseY>Y && mouseY<Y+R ) {
      if ( state3 == 0 ) {
        state3 = 1;
      } 
      else {
        state3 = 0;
      }
    }
    if ( mouseX>T4X && mouseX<T4X+R && mouseY>Y && mouseY<Y+R ) {
      if ( state4 == 0 ) {
        state4 = 1;
      } 
      else {
        state4 = 0;
      }
    }
    if ( mouseX>T5X && mouseX<T5X+R && mouseY>Y && mouseY<Y+R ) {
      if ( state5 == 0 ) {
        state5 = 1;
      } 
      else {
        state5 = 0;
      }
    }
  }
}

class Ntoggles {
  float T1X, T2X, T3X, T4X, T5X, Y, R, state1, state2, state3, state4, state5, T1F, T2F, T3F, T4F, T5F;
  Ntoggles(float T1X, float T2X, float T3X, float T4X, float T5X, float Y, float R, float state1, 
  float state2, float state3, float state4, float state5, float T1F, float T2F, float T3F, float T4F, 
  float T5F) {
    this.T1X=T1X;
    this.T2X=T2X;
    this.T3X=T3X;
    this.T4X=T4X;
    this.T5X=T5X;
    this.Y=Y;
    this.R=R;
    this.state1=state1;
    this.state2=state2;
    this.state3=state3;
    this.state4=state4;
    this.state5=state5;
    this.T1F=T1F;
    this.T2F=T2F;
    this.T3F=T3F;
    this.T4F=T4F;
    this.T5F=T5F;
  }

  public void update() {
    if ( state1 == 1 ) {
      switch(keyCode) {
      case'1':
        num1=1;
        break;
      case'2':
        num1=2;
        break;
      case'3':
        num1=3;
        break;
      case'4':
        num1=4;
        break;
      case'5':
        num1=5;
        break;
      case'6':
        num1=6;
        break;
      case'7':
        num1=7;
        break;
      case'8':
        num1=8;
        break;
      case'9':
        num1=9;
        break;
      case'0':
        num1=10;
        break;
      }
      T1F=mainCB;
    } 
    else {
      T1F=120;
    }
    if ( state2 == 1 ) {
      switch(keyCode) {
      case'1':
        num2=1;
        break;
      case'2':
        num2=2;
        break;
      case'3':
        num2=3;
        break;
      case'4':
        num2=4;
        break;
      case'5':
        num2=5;
        break;
      case'6':
        num2=6;
        break;
      case'7':
        num2=7;
        break;
      case'8':
        num2=8;
        break;
      case'9':
        num2=9;
        break;
      case'0':
        num2=10;
        break;
      }
      T2F=mainCB;
    } 
    else {
      T2F=120;
    }
    if ( state3 == 1 ) {
      switch(keyCode) {
      case'1':
        num3=1;
        break;
      case'2':
        num3=2;
        break;
      case'3':
        num3=3;
        break;
      case'4':
        num3=4;
        break;
      case'5':
        num3=5;
        break;
      case'6':
        num3=6;
        break;
      case'7':
        num3=7;
        break;
      case'8':
        num3=8;
        break;
      case'9':
        num3=9;
        break;
      case'0':
        num3=10;
        break;
      }
      T3F=mainCB;
    } 
    else {
      T3F=120;
    }
    if ( state4 == 1 ) {
      switch(keyCode) {
      case'1':
        num4=1;
        break;
      case'2':
        num4=2;
        break;
      case'3':
        num4=3;
        break;
      case'4':
        num4=4;
        break;
      case'5':
        num4=5;
        break;
      case'6':
        num4=6;
        break;
      case'7':
        num4=7;
        break;
      case'8':
        num4=8;
        break;
      case'9':
        num4=9;
        break;
      case'0':
        num4=10;
        break;
      }
      T4F=mainCB;
    } 
    else {
      T4F=120;
    }
    if ( state5 == 1 ) {
      switch(keyCode) {
      case'1':
        num5=1;
        break;
      case'2':
        num5=2;
        break;
      case'3':
        num5=3;
        break;
      case'4':
        num5=4;
        break;
      case'5':
        num5=5;
        break;
      case'6':
        num5=6;
        break;
      case'7':
        num5=7;
        break;
      case'8':
        num5=8;
        break;
      case'9':
        num5=9;
        break;
      case'0':
        num5=10;
        break;
      }
      T5F=mainCB;
    } 
    else {
      T5F=120;
    }
  }

  public void display() {
    stroke(120);
    strokeWeight(1);
    fill(mainCW, 200);
    rect(T1X-10, Y/3, width/2.5f, height/7.7f);
    fill(T1F);
    rect(T1X, Y, R, R);
    fill(T2F);
    rect(T2X, Y, R, R);
    fill(T3F);
    rect(T3X, Y, R, R);
    fill(T4F);
    rect(T4X, Y, R, R);
    fill(T5F);
    rect(T5X, Y, R, R);
    fill(120);
    textSize(20);
    text("A-Num (1~10)", T1X+75, Y-20);
    textSize(10);
    text("S1", T1X+5, Y);
    text("S2", T2X+5, Y);
    text("S3", T3X+5, Y);
    text("S4", T4X+5, Y);
    text("S5", T5X+5, Y);
    textSize(30);
    text(num1, T1X+50, Y+20);
    text(num2, T2X+50, Y+20);
    text(num3, T3X+50, Y+20);
    text(num4, T4X+50, Y+20);
    text(num5, T5X+50, Y+20);
  }

  public void changeModule() {
    if ( mouseX>T1X && mouseX<T1X+R && mouseY>Y && mouseY<Y+R ) {
      if ( state1 == 0 ) {
        state1 = 1;
      } 
      else {
        state1 = 0;
      }
    }
    if ( mouseX>T2X && mouseX<T2X+R && mouseY>Y && mouseY<Y+R ) {
      if ( state2 == 0 ) {
        state2 = 1;
      } 
      else {
        state2 = 0;
      }
    }
    if ( mouseX>T3X && mouseX<T3X+R && mouseY>Y && mouseY<Y+R ) {
      if ( state3 == 0 ) {
        state3 = 1;
      } 
      else {
        state3 = 0;
      }
    }
    if ( mouseX>T4X && mouseX<T4X+R && mouseY>Y && mouseY<Y+R ) {
      if ( state4 == 0 ) {
        state4 = 1;
      } 
      else {
        state4 = 0;
      }
    }
    if ( mouseX>T5X && mouseX<T5X+R && mouseY>Y && mouseY<Y+R ) {
      if ( state5 == 0 ) {
        state5 = 1;
      } 
      else {
        state5 = 0;
      }
    }
  }
}

class module1 {
  float X, Y, amX, amY, R, BR, BG, BB;
  module1(float X, float Y, float amX, float amY, float R, float BR, 
  float BG, float BB) {
    this.X=X;
    this.Y=Y;
    this.amX=amX;
    this.amY=amY;
    this.R=R;
    this.BR=BR;
    this.BG=BG;
    this.BB=BB;
  }

  public void display() {
    if (X>width-R/2 || X<R/2) {
      sound1.trigger();
      amX=-amX;
    }
    if (X>width-R || X<R) {
      bounce();
    }
    if (Y>height-R/2 || Y<R/2) {
      sound1.trigger();
      amY=-amY;
    }
    if (Y>height-R || Y<R) {
      bounce();
    }
    X=X+amX;
    Y=Y+amY;
    noStroke();
    fill(mainCB);
    ellipse(X, Y, R, R);
    fill(mainCW);
    textSize(R/2);
    text(".s1", X, Y+5);
  }

  public void bounce() {
    stroke(BR, BG, BB);
    noFill();
    strokeWeight(15);
    ellipse(X, Y, R*2, R*2);
  }
}

class module2 {
  float X, Y, amX, amY, R, BR, BG, BB;
  module2(float X, float Y, float amX, float amY, float R, float BR, 
  float BG, float BB) {
    this.X=X;
    this.Y=Y;
    this.amX=amX;
    this.amY=amY;
    this.R=R;
    this.BR=BR;
    this.BG=BG;
    this.BB=BB;
  }

  public void display() {
    if (X>width-R/2 || X<R/2) {
      sound2.trigger();
      amX=-amX;
    }
    if (X>width-R || X<R) {
      bounce();
    }
    if (Y>height-R/2 || Y<R/2) {
      sound2.trigger();
      amY=-amY;
    }
    if (Y>height-R || Y<R) {
      bounce();
    }
    X=X+amX;
    Y=Y+amY;
    noStroke();
    fill(mainCB);
    ellipse(X, Y, R, R);
    fill(mainCW);
    textSize(R/2);
    text(".s2", X, Y+5);
  }

  public void bounce() {
    stroke(BR, BG, BB);
    noFill();
    strokeWeight(15);
    ellipse(X, Y, R*2, R*2);
  }
}

class module3 {
  float X, Y, amX, amY, R, BR, BG, BB;
  module3(float X, float Y, float amX, float amY, float R, float BR, 
  float BG, float BB) {
    this.X=X;
    this.Y=Y;
    this.amX=amX;
    this.amY=amY;
    this.R=R;
    this.BR=BR;
    this.BG=BG;
    this.BB=BB;
  }

  public void display() {
    if (X>width-R/2 || X<R/2) {
      sound3.trigger();
      amX=-amX;
    }
    if (X>width-R || X<R) {
      bounce();
    }
    if (Y>height-R/2 || Y<R/2) {
      sound3.trigger();
      amY=-amY;
    }
    if (Y>height-R || Y<R) {
      bounce();
    }
    X=X+amX;
    Y=Y+amY;
    noStroke();
    fill(mainCB);
    ellipse(X, Y, R, R);
    fill(mainCW);
    textSize(R/2);
    text(".s3", X, Y+5);
  }

  public void bounce() {
    stroke(BR, BG, BB);
    noFill();
    strokeWeight(15);
    ellipse(X, Y, R*2, R*2);
  }
}

class module4 {
  float X, Y, amX, amY, R, BR, BG, BB;
  module4(float X, float Y, float amX, float amY, float R, float BR, 
  float BG, float BB) {
    this.X=X;
    this.Y=Y;
    this.amX=amX;
    this.amY=amY;
    this.R=R;
    this.BR=BR;
    this.BG=BG;
    this.BB=BB;
  }

  public void display() {
    if (X>width-R/2 || X<R/2) {
      sound4.trigger();
      amX=-amX;
    }
    if (X>width-R || X<R) {
      bounce();
    }
    if (Y>height-R/2 || Y<R/2) {
      sound4.trigger();
      amY=-amY;
    }
    if (Y>height-R || Y<R) {
      bounce();
    }
    X=X+amX;
    Y=Y+amY;
    noStroke();
    fill(mainCB);
    ellipse(X, Y, R, R);
    fill(mainCW);
    textSize(R/2);
    text(".s4", X, Y+5);
  }

  public void bounce() {
    stroke(BR, BG, BB);
    noFill();
    strokeWeight(15);
    ellipse(X, Y, R*2, R*2);
  }
}

class module5 {
  float X, Y, amX, amY, R, BR, BG, BB;
  module5(float X, float Y, float amX, float amY, float R, float BR, 
  float BG, float BB) {
    this.X=X;
    this.Y=Y;
    this.amX=amX;
    this.amY=amY;
    this.R=R;
    this.BR=BR;
    this.BG=BG;
    this.BB=BB;
  }

  public void display() {
    if (X>width-R/2 || X<R/2) {
      sound5.trigger();
      amX=-amX;
    }
    if (X>width-R || X<R) {
      bounce();
    }
    if (Y>height-R/2 || Y<R/2) {
      sound5.trigger();
      amY=-amY;
    }
    if (Y>height-R || Y<R) {
      bounce();
    }
    X=X+amX;
    Y=Y+amY;
    noStroke();
    fill(mainCB);
    ellipse(X, Y, R, R);
    fill(mainCW);
    textSize(R/2);
    text(".s5", X, Y+5);
  }

  public void bounce() {
    stroke(BR, BG, BB);
    noFill();
    strokeWeight(15);
    ellipse(X, Y, R*2, R*2);
  }
}

  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "--full-screen", "--bgcolor=#666666", "--hide-stop", "ball_MI" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
